<?php

namespace UnicaenDbImport\Entity\Db;

use UnicaenDbImport\Entity\Db\Interfaces\SourceInterface;

/**
 * AbstractSource
 */
abstract class AbstractSource implements SourceInterface
{
    /**
     * @var int
     */
    protected $id;

    /**
     * @var string
     */
    protected $code;

    /**
     * @var boolean
     */
    protected $importable;

    /**
     * @var string
     */
    protected $libelle;

    /**
     * Get id
     *
     * @return int
     */
    public function getId(): int
    {
        return $this->id;
    }

    /**
     * Set code
     *
     * @param string $code
     */
    public function setCode(string $code)
    {
        $this->code = $code;
    }

    /**
     * Get code
     *
     * @return string
     */
    public function getCode(): string
    {
        return $this->code;
    }

    /**
     * Set importable
     *
     * @param boolean $importable
     */
    public function setImportable(bool $importable)
    {
        $this->importable = $importable;
    }

    /**
     * Get importable
     *
     * @return boolean
     */
    public function getImportable(): bool
    {
        return $this->importable;
    }

    /**
     * Set libelle
     *
     * @param string $libelle
     */
    public function setLibelle(string $libelle)
    {
        $this->libelle = $libelle;
    }

    /**
     * Get libelle
     *
     * @return string
     */
    public function getLibelle(): string
    {
        return $this->libelle;
    }

    /**
     * Retourne la représentation littérale de cet objet.
     *
     * @return string
     */
    public function __toString(): string
    {
        return $this->getLibelle();
    }
}