<?php

namespace UnicaenDbImport\Service\Facade;

use Psr\Container\ContainerInterface;
use Psr\Log\NullLogger;
use UnicaenDbImport\Service\Database\DatabaseService;

class LogFacadeServiceFactory
{
    /**
     * @param ContainerInterface $container
     * @return LogFacadeService
     * @throws \Psr\Container\ContainerExceptionInterface
     * @throws \Psr\Container\NotFoundExceptionInterface
     */
    public function __invoke(ContainerInterface $container): LogFacadeService
    {
        /** @var DatabaseService $databaseService */
        $databaseService = $container->get(DatabaseService::class);

        $facade = new LogFacadeService($databaseService);
        $facade->setLogger(new NullLogger());

        return $facade;
    }
}